<?php

declare(strict_types=1);

namespace Dedi\SyliusMarketingPlugin\Storage;

use Symfony\Component\HttpFoundation\RequestStack;

class SessionManager implements SessionManagerInterface
{
    private RequestStack $requestStack;

    public function __construct(RequestStack $requestStack)
    {
        $this->requestStack = $requestStack;
    }

    public function storeInSession(string $key, array $data): void
    {
        $session = $this->requestStack->getSession();
        $storedData = $session->get($key) ?? [];
        $session->set($key, array_merge($storedData, $data));
    }

    public function getFromSession(string $key)
    {
        return $this->requestStack->getSession()->get($key);
    }
}
